! FIND THE COEFF
	parameter (N=8)
	real theta(0:N),x(0:N),z(0:N)
	real T(0:N,0:N),COEF(0:N)

	PI = 4.0*atan(1.0)
	do i=0,N
	theta(i) = i*PI/N
	x(i)     =cos(theta(i))    !cheb-domain
	z(i)     = (x(i) +1)/2.0   !physical-doamin
	enddo
!-----------------------------------------
! Cheb @ THETA(I)
	DO I=0,N
	 COEF(I) = exp(Z(I))
	DO J=0,N
	 T(I,J)= COS(J*THETA(I))
	ENDDO
	ENDDO
!--------------------------------
! solve
	call GESS (N+1,T,N+1,COEF,N+1,1,cond)
	write(*,*) 'cond=',cond
	write(*,*)'----------------'
	write(*,*) 'index, coef'
	DO i=0,N
	 WRITE(*,*)i,COEF(i)
	ENDDO

!-------------------------------
! check the sum
	write(*,*) '======================='
	write(*,*) 'Z,exp,approx,dapprox,error'
	DO i=0,10
	 ZTMP = i* 1/10.0
	 CALL chebsum(ZTMP,COEF,N,SUM,DSUM)
 	write(*,*) ZTMP, exp(ZTMP),SUM,DSUM, exp(ZTMP)-SUM
	ENDDO
!-------------------------------
	END

!---------------------------------
!---------------------------------
!---------------------------------
	subroutine chebsum(Z,COEF,N,SUM,DSUM)
	real COEF(0:0)
	real,allocatable ::T(:),DT(:)

	allocate ( T(0:N),DT(0:N) )

	X = 2*Z-1	!the map
	DXDZ=2

!compute cheb by recursion in cheb-domain
	T(0) =1.
	T(1) =X
	
! T(n+1) = 2x*T(n) -T(n-1)
	do j=2,N
	 T(j) =2.0*x*T(j-1)-T(j-2)
	enddo
!--------------------------------
! 1st deriv
! dT(n)= 2*n*T(n-1) + dT(n-2)*n/(n-2)

	DT(0)=0
	DT(1)=1
	DT(2)=4*X
	DO I=3,N
	 DT(i)=2*i*T(i-1) + DT(i-2)*i/(i-2)
	ENDDO

!---------------------------------
	SUM=0.0
	DSUM=0.0
	do j=0,N
	 SUM=SUM+ COEF(j)*T(j)
	 DSUM=DSUM+ COEF(j)*DT(j)*DXDZ
	enddo	

	deallocate(T,DT)	
	return
	end
